import { h, createContext, Fragment } from 'preact';
import { useRef } from 'preact/hooks';
import render from 'preact-render-to-string';
export const __DocContext = createContext({ head: { current: [] } });
export const Document = ({ styles = [], hasScripts = false, children }) => {
    const head = useRef([]);
    const subtree = render(h(__DocContext.Provider, { value: { head } }, children), {}, {});
    return (h("html", null,
        h("head", null,
            h("meta", { charSet: "utf-8" }),
            h("meta", { name: "viewport", content: "width=device-width" }),
            h(Fragment, null, head.current),
            styles.map(style => h("style", { dangerouslySetInnerHTML: { __html: style } }))),
        h("body", null,
            h("div", { id: "__microsite", dangerouslySetInnerHTML: { __html: subtree } }),
            hasScripts ? (h(h, null,
                h("script", { type: "module", src: "/index.js" }),
                h("script", Object.assign({}, { nomodule: '' }, { src: "https://unpkg.com/systemjs@2.0.0/dist/s.min.js" })),
                h("script", Object.assign({}, { nomodule: '' }, { src: "/index.legacy.js" })))) : null)));
};
